#!/usr/bin/perl
#
# Helper program to write a new IPAC settings file
#
# (c) Lawrence Manning, 2001

require '/var/smoothwall/header.pl';

my %settings;

readhash("${swroot}/ethernet/settings", \%settings);

if (!open(FILE, '>/etc/ipac-ng/ipac.rules')) {
	die "Unable to create ipac.rules"; }

print FILE "Incoming GREEN Direct|ipac~o|$settings{'GREEN_DEV'}|all||\n";
print FILE "Outgoing GREEN Direct|ipac~i|$settings{'GREEN_DEV'}|all||\n";
print FILE "Incoming GREEN Forward|ipac~fi|$settings{'GREEN_DEV'}|all||\n";
print FILE "Outgoing GREEN Forward|ipac~fo|$settings{'GREEN_DEV'}|all||\n";

if ($settings{'CONFIG_TYPE'} == 1 || $settings{'CONFIG_TYPE'} == 3)
{
        print FILE "Incoming ORANGE Direct|ipac~o|$settings{'ORANGE_DEV'}|all||\n";
	print FILE "Outgoing ORANGE Direct|ipac~i|$settings{'ORANGE_DEV'}|all||\n";
        print FILE "Incoming ORANGE Forward|ipac~fi|$settings{'ORANGE_DEV'}|all||\n";
	print FILE "Outgoing ORANGE Forward|ipac~fo|$settings{'ORANGE_DEV'}|all||\n";

}

if ($settings{'CONFIG_TYPE'} == 0 || $settings{'CONFIG_TYPE'} == 1 ||
	$settings{'RED_TYPE'} eq 'PPPOE')
{
	print FILE "Incoming RED (PPP) Direct|ipac~o|ppp0|all||\n";
	print FILE "Outgoing RED (PPP) Direct|ipac~i|ppp0|all||\n";
	print FILE "Incoming RED (ISDN PPP) Direct|ipac~o|ippp0|all||\n";
	print FILE "Outgoing RED (ISDN PPP) Direct|ipac~i|ippp0|all||\n";
	print FILE "Incoming RED (PPP) Forward|ipac~fi|ppp0|all||\n";
	print FILE "Outgoing RED (PPP) Forward|ipac~fo|ppp0|all||\n";
	print FILE "Incoming RED (ISDN PPP) Forward|ipac~fi|ippp0|all||\n";
	print FILE "Outgoing RED (ISDN PPP) Forward|ipac~fo|ippp0|all||\n";
}
else
{
	print FILE "Incoming RED Direct|ipac~o|$settings{'RED_DEV'}|all||\n";
	print FILE "Outgoing RED Direct|ipac~i|$settings{'RED_DEV'}|all||\n";
	print FILE "Incoming RED Forward|ipac~fi|$settings{'RED_DEV'}|all||\n";
	print FILE "Outgoing RED Forward|ipac~fo|$settings{'RED_DEV'}|all||\n";
}

&bandviewipac;	###bandview v0.6.2

close FILE;

###START###bandview v0.6.2 subroutines
sub bandviewipac {
	my $bandviewsettings;
	$bandviewsettings{'BAND_USERLIST'} = "${swroot}/preferences/bandview-userlist";
#	readhash2("${swroot}/preferences/bandview", \%bandviewsettings);

	if (-e $bandviewsettings{'BAND_USERLIST'}) {
		@bandviewUSERS = `cat $bandviewsettings{'BAND_USERLIST'}`;

		my %proxysettings;
		readhash2("${swroot}/proxy/settings", \%proxysettings);

		for ($i=0; $i <= $#bandviewUSERS; $i++){
			chomp ($bandviewUSERS[$i]);
			my @bandviewmembership = split(/\,/,$bandviewUSERS[$i]);
			$bandviewusername = $bandviewmembership[0];
			$bandviewuserip = $bandviewmembership[1];

			if ($settings{'CONFIG_TYPE'} == 0 || $settings{'CONFIG_TYPE'} == 1 || $settings{'RED_TYPE'} eq 'PPPOE') {
				print FILE "$bandviewusername in|ipac~fi|ppp0|all||$bandviewuserip\n";
				print FILE "$bandviewusername out|ipac~fo|ppp0|all|$bandviewuserip|\n";
				print FILE "$bandviewusername in|ipac~fi|ippp0|all||$bandviewuserip\n";
				print FILE "$bandviewusername out|ipac~fo|ippp0|all|$bandviewuserip|\n";
			} else {
				print FILE "$bandviewusername in|ipac~fi|$settings{'RED_DEV'}|all||$bandviewuserip\n";
				print FILE "$bandviewusername out|ipac~fo|$settings{'RED_DEV'}|all|$bandviewuserip|\n";
			}

			if ($proxysettings{'ENABLE'} eq "on") {
				if ($proxysettings{'TRANSPARENT'} eq "on") {
					print FILE "$bandviewusername in|ipac~i|$settings{'GREEN_DEV'}|all||$bandviewuserip\n";
				} elsif ($proxysettings{'TRANSPARENT'} eq "off") {
					print FILE "$bandviewusername in|ipac~i|$settings{'GREEN_DEV'}|tcp|0/0 800|$bandviewuserip\n";	###changed "all" to "tcp"
				}
			} else {
				###then do nothing	
			}
		}
	}
}

sub readhash2	###routine adapted from header.pl by The Smoothwall Team
{
	my $filename = $_[0];
	my $hash = $_[1];
	my ($var, $val);

	open(FILE2, $filename) or die "Unable to read file $filename";
	
	while (<FILE2>)
	{
		chop;
		($var, $val) = split /=/, $_, 2;
		if ($var)
		{
			$val =~ s/^\'//g;
			$val =~ s/\'$//g;
			$hash->{$var} = $val;
		}
	}
	close FILE2;
}
###END###bandview v0.6.2 subroutines
